"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ToggleDirective = /** @class */ (function () {
    function ToggleDirective(elementRef) {
        this.elementRef = elementRef;
    }
    ToggleDirective.prototype.onClick = function () {
        if (this.handleFunc) {
            this.handleFunc(this.target);
        }
        return !this.target || this.target.toggle();
    };
    ToggleDirective.prototype.onBlur = function ($event) {
        return !this.blur || this.blur($event);
    };
    Object.defineProperty(ToggleDirective.prototype, "dom", {
        get: function () {
            return this.elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    ToggleDirective.prototype.ngAfterViewInit = function () {
        if (this.bind) {
            this.bind.bind(this);
        }
    };
    ToggleDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[tsToggle]",
                    exportAs: 'tsToggle'
                },] },
    ];
    /** @nocollapse */
    ToggleDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    ToggleDirective.propDecorators = {
        "target": [{ type: core_1.Input },],
        "bind": [{ type: core_1.Input },],
        "handleFunc": [{ type: core_1.Input },],
        "onClick": [{ type: core_1.HostListener, args: ['click',] },],
        "onBlur": [{ type: core_1.HostListener, args: ['blur', ['$event'],] },],
    };
    return ToggleDirective;
}());
exports.ToggleDirective = ToggleDirective;
//# sourceMappingURL=toggle.directives.js.map