"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Size;
(function (Size) {
    Size["sm"] = "sm";
    Size["default"] = "";
    Size["lg"] = "lg";
})(Size = exports.Size || (exports.Size = {}));
var Color;
(function (Color) {
    Color["default"] = "white";
    Color["white"] = "white";
    Color["danger"] = "danger";
    Color["warning"] = "warning";
    Color["dark"] = "dark";
    Color["light"] = "light";
    Color["secondary"] = "secondary";
    Color["primary"] = "primary";
})(Color = exports.Color || (exports.Color = {}));
exports.LightColors = [
    'white',
    'muted',
    'warning',
    'light'
];
var DomAttr = /** @class */ (function () {
    function DomAttr() {
        this.lg = null;
        this.sm = null;
        this.md = null;
        this.xl = null;
        this.color = Color.default;
        this.outline = null;
        this.active = null;
    }
    Object.defineProperty(DomAttr.prototype, "btnClass", {
        get: function () {
            var active = this.active === null ? '' : 'active';
            var outline = this.outline === null ? '' : 'outline-';
            var size = this.lg !== null ? 'btn-lg' : (this.sm !== null ? 'btn-sm' : '');
            return "btn " + size + " btn-" + outline + this.color + " " + active;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "bgClass", {
        get: function () {
            return "bg-" + this.color;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "textClass", {
        get: function () {
            return "text-" + this.color;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "lightOrDark", {
        get: function () {
            return exports.LightColors.indexOf(this.color) >= 0 ? 'light' : 'dark';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "inLightOrDark", {
        get: function () {
            return exports.LightColors.indexOf(this.color) < 0 ? 'light' : 'dark';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "browserSize", {
        get: function () {
            if (this.xl !== null) {
                return 'xl';
            }
            if (this.lg !== null) {
                return 'lg';
            }
            if (this.md !== null) {
                return 'md';
            }
            if (this.sm !== null) {
                return 'sm';
            }
            return 'md';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "borderClass", {
        get: function () {
            return "border-" + this.color;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomAttr.prototype, "tabClass", {
        get: function () {
            return "tab-border-" + this.color;
        },
        enumerable: true,
        configurable: true
    });
    DomAttr.propDecorators = {
        "lg": [{ type: core_1.Input },],
        "sm": [{ type: core_1.Input },],
        "md": [{ type: core_1.Input },],
        "xl": [{ type: core_1.Input },],
        "color": [{ type: core_1.Input },],
        "outline": [{ type: core_1.Input },],
        "active": [{ type: core_1.Input },],
    };
    return DomAttr;
}());
exports.DomAttr = DomAttr;
//# sourceMappingURL=attr.class.js.map