"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Subject_1 = require("rxjs/Subject");
var ScriptService = /** @class */ (function () {
    function ScriptService() {
    }
    ScriptService.prototype.load = function (src, target) {
        var _this = this;
        this.isReady = false;
        this.src = src;
        var body = document.querySelector('body');
        this.useScript = new Subject_1.Subject();
        if (target) {
            this.isReady = true;
            this.useScript.complete();
        }
        else {
            var node = document.createElement('script');
            node.async = true;
            node.type = 'text/javascript';
            node.src = src;
            node.charset = 'utf-8';
            document.getElementsByTagName('head')[0].appendChild(node);
            node.addEventListener('load', function () {
                _this.isReady = true;
                _this.useScript.complete();
            });
        }
        return this.useScript;
    };
    ScriptService.prototype.complete = function (func) {
        this.useScript.subscribe({ complete: function () { return func(); } });
    };
    ScriptService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ScriptService.ctorParameters = function () { return []; };
    return ScriptService;
}());
exports.ScriptService = ScriptService;
//# sourceMappingURL=script.service.js.map