"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var attr_class_1 = require("./../../commons/extends/attr.class");
var ButtonsComponent = /** @class */ (function (_super) {
    __extends(ButtonsComponent, _super);
    function ButtonsComponent(domSanitizer) {
        var _this = _super.call(this) || this;
        _this.domSanitizer = domSanitizer;
        _this.valueChange = new core_1.EventEmitter();
        _this.multi = false;
        _this.items = new Array();
        return _this;
    }
    Object.defineProperty(ButtonsComponent.prototype, "buttons", {
        get: function () {
            var _this = this;
            return this.items.map(function (btn) {
                return {
                    value: btn.value,
                    content: _this.domSanitizer.bypassSecurityTrustHtml(btn.content)
                };
            });
        },
        enumerable: true,
        configurable: true
    });
    ButtonsComponent.prototype.toggle = function (btn) {
        if (this.isActive(btn.value)) {
            this.multi ? this.removeMutiValue(btn.value) : this.value = null;
        }
        else {
            this.multi ? this.value.push(btn.value) : this.value = btn.value;
        }
        this.valueChange.emit(this.multi ? this.value.concat() : this.value);
    };
    ButtonsComponent.prototype.removeMutiValue = function (value) {
        if (this.value && this.value instanceof Array) {
            var index = this.value.indexOf(value);
            if (index >= 0) {
                this.value.splice(index, 1);
            }
        }
    };
    ButtonsComponent.prototype.isActive = function (value) {
        return this.multi ? this.multiActive(value) : this.value === value;
    };
    ButtonsComponent.prototype.multiActive = function (value) {
        return (this.value && this.value instanceof Array) ? this.value.indexOf(value) >= 0 : false;
    };
    ButtonsComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-btns',
                    template: "\n    <div class=\"btn-group\" role=\"group\" aria-label=\"Basic example\">\n        <button (click)=\"toggle(btn)\"\n        *ngFor=\"let btn of buttons\"\n        type=\"button\"\n        [class]=\"btnClass+(isActive(btn.value)?'active':'')\"\n        [innerHTML]=\"btn.content\"></button>\n    </div>\n    ",
                },] },
    ];
    /** @nocollapse */
    ButtonsComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    ButtonsComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "value": [{ type: core_1.Input },],
        "valueChange": [{ type: core_1.Output },],
        "multi": [{ type: core_1.Input },],
    };
    return ButtonsComponent;
}(attr_class_1.DomAttr));
exports.ButtonsComponent = ButtonsComponent;
//# sourceMappingURL=buttons.component.js.map