"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var checkbox_component_1 = require("./checkbox.component");
var CheckboxDirective = /** @class */ (function () {
    function CheckboxDirective(cdRef) {
        this.cdRef = cdRef;
        this.valuesChange = new core_1.EventEmitter();
    }
    CheckboxDirective.prototype.ngAfterContentInit = function () {
        this.replyValue();
    };
    CheckboxDirective.prototype.ngOnChanges = function (simpleChanges) {
        if (simpleChanges.values && !simpleChanges.values.isFirstChange()) {
            this.replyValue();
        }
    };
    CheckboxDirective.prototype.replyValue = function () {
        var checkboxList = this.checkboxList.toArray();
        for (var _i = 0, checkboxList_1 = checkboxList; _i < checkboxList_1.length; _i++) {
            var checkbox = checkboxList_1[_i];
            if (this.values.indexOf(checkbox.value) >= 0) {
                checkbox.checked = true;
            }
            else {
                checkbox.checked = false;
            }
        }
        this.cdRef.detectChanges();
    };
    CheckboxDirective.prototype.applyCheckboxChange = function () {
        var _this = this;
        this.values = [];
        this.checkboxList.forEach(function (checkbox) {
            if (checkbox.checked) {
                _this.values.push(checkbox.value);
            }
        });
        this.valuesChange.emit(this.values);
        this.cdRef.detectChanges();
    };
    CheckboxDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '*[tsCheckboxGroup]',
                    exportAs: 'tsCheckboxGroup'
                },] },
    ];
    /** @nocollapse */
    CheckboxDirective.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
    ]; };
    CheckboxDirective.propDecorators = {
        "values": [{ type: core_1.Input },],
        "valuesChange": [{ type: core_1.Output },],
        "checkboxList": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return checkbox_component_1.CheckboxComponent; }),] },],
    };
    return CheckboxDirective;
}());
exports.CheckboxDirective = CheckboxDirective;
//# sourceMappingURL=checkboxs.direvtive.js.map