"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("./../../commons/extends/attr.class");
var RadioComponent = /** @class */ (function (_super) {
    __extends(RadioComponent, _super);
    function RadioComponent() {
        var _this = _super.call(this) || this;
        // radio被选中状态变更时触发
        _this.checkedChange = new core_1.EventEmitter(false);
        // radio状态变更的绑定handle
        _this.groupHandle = new core_1.EventEmitter(false);
        _this.checked = false;
        return _this;
    }
    RadioComponent.prototype.changeStatus = function () {
        this.checked = !this.checked;
        this.checkedChange.emit(this.checked);
        this.groupHandle.emit({ checked: this.checked, value: this.value });
    };
    RadioComponent.prototype.ngOnDestroy = function () {
        this.groupHandle.emit({ checked: this.checked });
    };
    RadioComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-radio',
                    template: "\n    <span (click)=\"changeStatus()\" class=\"pointer {{textClass}}\">\n        <i *ngIf=\"!checked\" class=\"fa fa-circle-o fa-fw fa-lg\"></i>\n        <i *ngIf=\"checked\" class=\"fa fa-dot-circle-o fa-fw fa-lg\"></i>\n    </span>\n    <span (click)=\"changeStatus()\" class=\"pointer\">{{label||''}}</span>",
                },] },
    ];
    /** @nocollapse */
    RadioComponent.ctorParameters = function () { return []; };
    RadioComponent.propDecorators = {
        "label": [{ type: core_1.Input },],
        "value": [{ type: core_1.Input },],
        "checked": [{ type: core_1.Input },],
        "defaultColor": [{ type: core_1.Input },],
        "checkedChange": [{ type: core_1.Output },],
        "groupHandle": [{ type: core_1.Output },],
    };
    return RadioComponent;
}(attr_class_1.DomAttr));
exports.RadioComponent = RadioComponent;
//# sourceMappingURL=radio.component.js.map