"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var radio_component_1 = require("./radio.component");
var RadiosDirective = /** @class */ (function () {
    function RadiosDirective(cdRef) {
        this.cdRef = cdRef;
        this.valueChange = new core_1.EventEmitter(false);
    }
    RadiosDirective.prototype.ngAfterContentInit = function () {
        this.replyValue();
    };
    RadiosDirective.prototype.ngOnChanges = function (simpleChanges) {
        if (simpleChanges.hasOwnProperty('value') && !simpleChanges.value.isFirstChange()) {
            this.replyValue();
        }
    };
    RadiosDirective.prototype.replyValue = function () {
        var radioList = this.radioList.toArray();
        for (var i = 0; i < this.radioList.length; i++) {
            if (radioList[i].value === this.value) {
                radioList[i].checked = true;
            }
            else {
                radioList[i].checked = false;
            }
        }
        this.cdRef.detectChanges();
    };
    RadiosDirective.prototype.applyRadioValue = function () {
        var _this = this;
        var radioList = this.radioList.toArray();
        radioList.forEach(function (radio) {
            if (_this.value !== radio.value) {
                radio.checked = false;
            }
        });
        this.cdRef.detectChanges();
    };
    RadiosDirective.prototype.applyRadioChange = function (handle) {
        if (handle.value !== undefined) {
            this.value = handle.checked === true ? handle.value : null;
            this.valueChange.emit(this.value);
        }
        else if (handle.checked === true) {
            this.value = null;
            this.valueChange.emit(this.value);
        }
        this.applyRadioValue();
    };
    RadiosDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '*[tsRadioGroup]',
                    exportAs: 'tsRadioGroup',
                },] },
    ];
    /** @nocollapse */
    RadiosDirective.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
    ]; };
    RadiosDirective.propDecorators = {
        "value": [{ type: core_1.Input },],
        "valueChange": [{ type: core_1.Output },],
        "radioList": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return radio_component_1.RadioComponent; }),] },],
    };
    return RadiosDirective;
}());
exports.RadiosDirective = RadiosDirective;
//# sourceMappingURL=radios.direvtive.js.map