"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Subject_1 = require("rxjs/Subject");
var confirm_data_1 = require("./confirm.data");
var ConfirmComponent = /** @class */ (function () {
    function ConfirmComponent(_options) {
        this.config = {
            okTitle: _options.okTitle,
            cancelTitle: _options.cancelTitle
        };
        this.show = false;
        this.color = 'success';
    }
    ConfirmComponent.prototype.tryClose = function (eventDom) {
        if (eventDom === this.modalPad.nativeElement) {
            this.dismiss();
        }
    };
    ConfirmComponent.prototype.dismiss = function () {
        this.show = false;
    };
    ConfirmComponent.prototype.confirm = function () {
        this.handle.next();
        this.show = false;
    };
    ConfirmComponent.prototype.play = function () {
        this.show = true;
    };
    ConfirmComponent.prototype.updateHandle = function () {
        this.handle = new Subject_1.Subject();
        return this.handle.asObservable();
    };
    ConfirmComponent.decorators = [
        { type: core_1.Component, args: [{
                    template: "\n    <div #pad (click)=\"tryClose($event.target)\" [class.show]=\"show\" [class.d-block]=\"show\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\">\n        <div class=\"modal-dialog modal-dialog-centered modal-sm\" role=\"document\">\n            <div class=\"modal-content\">\n                <div class=\"modal-header\">\n                    <h5 class=\"modal-title\">\n                        <i *ngIf=\"config.icon\" [class]=\"config.icon\"></i>\n                        {{title}}\n                    </h5>\n                    <button (click)=\"dismiss()\" type=\"button\" class=\"close\">\n                        <span aria-hidden=\"true\">&times;</span>\n                    </button>\n                 </div>\n                <div class=\"modal-body\">\n                    <p>{{message}}</p>\n                </div>\n                <div class=\"modal-footer\">\n                    <button (click)=\"dismiss()\" type=\"button\" class=\"btn btn-white\">{{config.cancelTitle}}</button>\n                    <button (click)=\"confirm()\" type=\"button\" class=\"btn btn-{{color}}\">{{config.okTitle}}</button>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div *ngIf=\"show\" class=\"modal-backdrop fade show\"></div>\n  "
                },] },
    ];
    /** @nocollapse */
    ConfirmComponent.ctorParameters = function () { return [
        { type: confirm_data_1.ConfirmConfig, },
    ]; };
    ConfirmComponent.propDecorators = {
        "modalPad": [{ type: core_1.ViewChild, args: ['pad',] },],
    };
    return ConfirmComponent;
}());
exports.ConfirmComponent = ConfirmComponent;
//# sourceMappingURL=confirm.component.js.map