"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var DropdownComponent = /** @class */ (function (_super) {
    __extends(DropdownComponent, _super);
    function DropdownComponent() {
        var _this = _super.call(this) || this;
        _this.valueChange = new core_1.EventEmitter();
        _this.itemChange = new core_1.EventEmitter();
        _this.items = [];
        _this.diyClass = null;
        _this.dropup = null;
        _this.page = null;
        return _this;
    }
    Object.defineProperty(DropdownComponent.prototype, "itemList", {
        get: function () {
            var _this = this;
            var items = new Array();
            // just need some number value
            if (this.useNumber >= 0) {
                this.items.some(function (item, index) {
                    if (typeof item === 'string') {
                        items.push({ value: _this.useNumber + index, text: item });
                    }
                    else if (typeof item === 'number') {
                        items.push({ value: _this.useNumber + item, text: item.toString() });
                    }
                    else {
                        console.error('useNumber >= 0,items element must be a string or number', item);
                        return false;
                    }
                });
            }
            else {
                // diy item value
                this.items.forEach(function (item) {
                    items.push(typeof item === 'string' || typeof item === 'number' ? { value: item, text: item } : item);
                });
            }
            return items;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DropdownComponent.prototype, "pageClass", {
        get: function () {
            return "btn-page-" + this.color;
        },
        enumerable: true,
        configurable: true
    });
    DropdownComponent.prototype.ngOnChanges = function (changes) {
        if (changes.value) {
            var items = this.itemList;
            for (var i = 0; i < items.length; i++) {
                if (items[i].value === changes.value.currentValue) {
                    this.item = items[i];
                }
            }
        }
    };
    DropdownComponent.prototype.itemClick = function (item) {
        this.item = item;
        this.valueChange.emit(item.value);
        this.itemChange.emit(item);
    };
    DropdownComponent.prototype.trackByValue = function (index, item) { return item.value; };
    DropdownComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-dropdown',
                    template: "\n    <div tsDropdown [dropup]=\"dropup\">\n        <button *ngIf=\"diyClass\" [class]=\"diyClass\" type=\"button\" tsToggle>{{item ? item.text : text}}</button>\n        <button *ngIf=\"!diyClass\"\n            tsToggle tsBtn\n            class=\"dropdown-toggle {{this.page!==null?pageClass:''}}\"\n            [lg]=\"lg\"\n            [sm]=\"sm\"\n            [outline]=\"outline\"\n            [color]=\"color\">{{item ? item.text : text}}</button>\n        <div tsDropMenu>\n            <button [class.active]=\"item.value === value\"\n                    class=\"dropdown-item pointer\"\n                    *ngFor=\"let item of itemList; trackBy: trackByValue\"\n                    (click)=\"itemClick(item)\">{{item.text}}</button>\n        </div>\n    </div>\n    ",
                    styles: [
                        ".btn-page-primary,\n        .btn-page-secondary,\n        .btn-page-success,\n        .btn-page-danger,\n        .btn-page-warning,\n        .btn-page-info,\n        .btn-page-dark{\n            border-color: #eee;\n        }\n\n        .btn-page-primary.disabled:hover,\n        .btn-page-secondary.disabled:hover,\n        .btn-page-success.disabled:hover,\n        .btn-page-danger.disabled:hover,\n        .btn-page-warning.disabled:hover,\n        .btn-page-info.disabled:hover,\n        .btn-page-dark.disabled:hover{\n            border-color: #eee !important;\n        }\n\n        .btn-page-primary:hover {\n            border-color: #007bff !important;\n        }\n        .btn-page-secondary:hover {\n            border-color: #6c757d !important;\n        }\n        .btn-page-success:hover {\n            border-color: #28a745 !important;\n        }\n        .btn-page-danger:hover {\n            border-color: #dc3545 !important;\n        }\n        .btn-page-warning:hover {\n            border-color: #ffc107 !important;\n        }\n        .btn-page-info:hover {\n            border-color: #17a2b8 !important;\n        }\n        .btn-page-dark:hover {\n            border-color: #343a40 !important;\n        }"
                    ]
                },] },
    ];
    /** @nocollapse */
    DropdownComponent.ctorParameters = function () { return []; };
    DropdownComponent.propDecorators = {
        "page": [{ type: core_1.Input },],
        "text": [{ type: core_1.Input },],
        "value": [{ type: core_1.Input },],
        "items": [{ type: core_1.Input },],
        "diyClass": [{ type: core_1.Input },],
        "dropup": [{ type: core_1.Input },],
        "useNumber": [{ type: core_1.Input },],
        "valueChange": [{ type: core_1.Output },],
        "itemChange": [{ type: core_1.Output },],
    };
    return DropdownComponent;
}(attr_class_1.DomAttr));
exports.DropdownComponent = DropdownComponent;
//# sourceMappingURL=dropdown.component.js.map