"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var modal_directive_1 = require("./modal.directive");
var ModalComponent = /** @class */ (function () {
    function ModalComponent(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.show = false;
        this.center = false;
        this.size = '';
    }
    ModalComponent.prototype.loadComponent = function (content) {
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(content);
        var viewContainerRef = this.modalHost.viewContainerRef;
        viewContainerRef.clear();
        var componentRef = viewContainerRef.createComponent(componentFactory);
        return componentRef;
    };
    ModalComponent.prototype.open = function () {
        this.show = true;
    };
    ModalComponent.prototype.close = function () {
        this.show = false;
    };
    ModalComponent.prototype.tryClose = function (event) {
        if (event.target === this.pad.nativeElement) {
            this.close();
        }
    };
    ModalComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-modal',
                    template: "\n    <div #pad class=\"modal fade\" (click)=\"tryClose($event)\" [ngClass]=\"{'show': show}\"\n        [ngStyle]=\"{'display': show?'block':'none',overflow:'auto'}\">\n        <div class=\"modal-dialog modal-{{size}}\" [class.modal-dialog-centered]=\"center\">\n            <div class=\"modal-content\">\n                <ng-template tsModalHost></ng-template>\n            </div>\n        </div>\n    </div>\n    <div *ngIf=\"show\" class=\"modal-backdrop fade show\"></div>",
                },] },
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: core_1.ComponentFactoryResolver, },
    ]; };
    ModalComponent.propDecorators = {
        "pad": [{ type: core_1.ViewChild, args: ['pad',] },],
        "modalHost": [{ type: core_1.ViewChild, args: [modal_directive_1.ModalDirective,] },],
    };
    return ModalComponent;
}());
exports.ModalComponent = ModalComponent;
//# sourceMappingURL=modal.component.js.map