"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var modal_component_1 = require("./modal.component");
var Subject_1 = require("rxjs/Subject");
var ModalService = /** @class */ (function () {
    function ModalService(applicationRef, componentFactoryResolver, injector) {
        this.applicationRef = applicationRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.injector = injector;
    }
    ModalService.prototype.init = function () {
        this.baseComponent = this.componentFactoryResolver.resolveComponentFactory(modal_component_1.ModalComponent);
        this.windowCmptRef = this.baseComponent.create(this.injector);
        this.applicationRef.attachView(this.windowCmptRef.hostView);
        this.containerEl = document.querySelector('body');
        this.containerEl.appendChild(this.windowCmptRef.location.nativeElement);
    };
    ModalService.prototype.create = function (content, options) {
        this.init();
        this.modalComponent = content;
        this.modal = this.windowCmptRef.instance.loadComponent(content);
        if (options !== undefined) {
            this.windowCmptRef.instance.size = options.size || '';
            this.windowCmptRef.instance.center = options.center || false;
        }
        return this;
    };
    Object.defineProperty(ModalService.prototype, "instance", {
        get: function () {
            return this.modal.instance;
        },
        enumerable: true,
        configurable: true
    });
    ModalService.prototype.close = function (params) {
        this.windowCmptRef.instance.close();
        this.windowCmptRef.destroy();
        if (this.handle) {
            this.handle.next(params);
        }
    };
    ModalService.prototype.dismiss = function () {
        this.windowCmptRef.instance.close();
        this.windowCmptRef.destroy();
    };
    ModalService.prototype.open = function () {
        this.windowCmptRef.instance.open();
        this.handle = new Subject_1.Subject();
        return this.handle.asObservable();
    };
    ModalService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ModalService.ctorParameters = function () { return [
        { type: core_1.ApplicationRef, },
        { type: core_1.ComponentFactoryResolver, },
        { type: core_1.Injector, },
    ]; };
    return ModalService;
}());
exports.ModalService = ModalService;
//# sourceMappingURL=modal.service.js.map