"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Pagination = /** @class */ (function () {
    function Pagination(total, page, limit) {
        if (total === void 0) { total = 0; }
        if (page === void 0) { page = 1; }
        if (limit === void 0) { limit = 10; }
        this.total = total;
        this.page = page;
        this.limit = limit;
    }
    Object.defineProperty(Pagination.prototype, "offset", {
        get: function () {
            return (this.page - 1) * this.limit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Pagination.prototype, "pageData", {
        get: function () {
            return { limit: this.limit, offset: this.offset };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Pagination.prototype, "maxPage", {
        get: function () {
            return Math.ceil(this.total / this.limit);
        },
        enumerable: true,
        configurable: true
    });
    Pagination.prototype.getpageDataWith = function (params) {
        if (params === void 0) { params = {}; }
        params.limit = this.limit;
        params.offset = this.offset;
        return params;
    };
    Pagination.prototype.reset = function () {
        this.total = 0;
        this.page = 1;
        this.limit = 10;
    };
    Pagination.prototype.hasNext = function () {
        return this.page < this.maxPage;
    };
    Pagination.prototype.hasPrev = function () {
        return this.page > 1;
    };
    Pagination.prototype.hasPage = function (page) {
        return page > 0 && page <= this.maxPage;
    };
    Pagination.prototype.pageValid = function () {
        return this.hasPage(this.page);
    };
    Pagination.prototype.clone = function () {
        return new Pagination(this.total, this.page, this.limit);
    };
    return Pagination;
}());
exports.Pagination = Pagination;
//# sourceMappingURL=pagination.class.js.map