"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var SelectComponent = /** @class */ (function (_super) {
    __extends(SelectComponent, _super);
    function SelectComponent() {
        var _this = _super.call(this) || this;
        _this.valueChange = new core_1.EventEmitter(false);
        _this.optionChange = new core_1.EventEmitter(false);
        _this.color = attr_class_1.Color.primary;
        _this.readonly = 'readonly';
        _this.disabled = false;
        _this.placeholder = 'select...';
        _this.searchKey = '';
        _this.title = '';
        _this.items = [];
        _this.emptyLabel = 'No results found.';
        return _this;
    }
    Object.defineProperty(SelectComponent.prototype, "itemsList", {
        get: function () {
            var _this = this;
            var items = this.formatItems;
            if (this.searchKey) {
                items = items.filter(function (e) { return e.text.indexOf(_this.searchKey) > -1; });
            }
            return items;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "formatItems", {
        get: function () {
            var items = new Array();
            if (this.items.length > 0) {
                this.items.forEach(function (e) {
                    items.push(typeof e === 'string' || typeof e === 'number' ? { value: e, text: e } : e);
                });
            }
            return items;
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.ngOnChanges = function () {
        this.setTitle();
    };
    SelectComponent.prototype.showActiveClass = function (item) {
        return item.value === this.value ? "text-" + this.inLightOrDark + " " + this.bgClass : '';
    };
    SelectComponent.prototype.trackByValue = function (index, item) { return item.value; };
    SelectComponent.prototype.setReadonlyStatus = function (status) {
        this.readonly = status ? null : 'readonly';
        if (status === false && this.searchKey.length > 0) {
            this.setTitle();
        }
    };
    SelectComponent.prototype.setValue = function (item) {
        this.readonly = 'readonly';
        this.value = item.value;
        this.title = item.text;
        this.searchKey = '';
        this.optionChange.emit(item);
        this.valueChange.emit(item.value);
    };
    SelectComponent.prototype.setSearchKey = function (value) {
        this.searchKey = value.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
    };
    SelectComponent.prototype.setTitle = function () {
        var items = this.formatItems;
        if (this.value !== undefined && this.value != null) {
            for (var i = 0; i < items.length; i++) {
                if (items[i].value === this.value) {
                    this.title = items[i].text;
                    return;
                }
            }
        }
        this.title = '';
    };
    SelectComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-select,*tsSelect',
                    template: "\n    <div tsDropdown class=\"w-100\">\n        <input tsToggle\n            [attr.readonly]=\"readonly\"\n            [class.custom-select-sm]=\"sm!==null\"\n            [class.custom-select-lg]=\"lg!==null\"\n            [(ngModel)]=\"title\" (ngModelChange)=\"setSearchKey($event)\" class=\"custom-select border-0 pointer\" type=\"text\"\n            [placeholder]=\"placeholder\">\n        <div (displayChange)=\"setReadonlyStatus($event)\" tsDropMenu [style.width]=\"'100%'\">\n            <div class=\"ts-select-item pointer border-none\">\n                <div *ngFor=\"let item of itemsList;trackBy: trackByValue\"\n                     class=\"dropdown-item {{showActiveClass(item)}}\"\n                     (click)=\"setValue(item)\"\n                     [innerHTML]=\"item.content||item.text\">\n                </div>\n                <div *ngIf=\"itemsList.length<=0\" class=\"text-muted text-center\">{{emptyLabel}}</div>\n            </div>\n        </div>\n    </div>",
                    styles: [
                        ".ts-select-item {\n            max-height: 270px;\n            overflow-y: auto;\n        }\n        .dropdown-item:active{\n            color: black;\n            background-color: #f8f9fa !important;\n        }"
                    ]
                },] },
    ];
    /** @nocollapse */
    SelectComponent.ctorParameters = function () { return []; };
    SelectComponent.propDecorators = {
        "disabled": [{ type: core_1.Input },],
        "items": [{ type: core_1.Input },],
        "placeholder": [{ type: core_1.Input },],
        "value": [{ type: core_1.Input },],
        "emptyLabel": [{ type: core_1.Input },],
        "valueChange": [{ type: core_1.Output },],
        "optionChange": [{ type: core_1.Output },],
    };
    return SelectComponent;
}(attr_class_1.DomAttr));
exports.SelectComponent = SelectComponent;
//# sourceMappingURL=select.component.js.map