"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var tab_directive_1 = require("./tab.directive");
var attr_class_1 = require("./../../commons/extends/attr.class");
var TabComponent = /** @class */ (function (_super) {
    __extends(TabComponent, _super);
    function TabComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tabChange = new core_1.EventEmitter();
        return _this;
    }
    TabComponent.prototype.ngAfterViewInit = function () {
        this.target.changeTab(this.activeTab || null);
    };
    TabComponent.prototype.changeTab = function (tab) {
        this.activeTab = tab;
        this.target.changeTab(tab);
    };
    TabComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-tabs',
                    template: "\n    <ul class=\"nav nav-tabs\" [class.justify-content-end]=\"position==='end'\" [class.justify-content-center]=\"position==='center'\">\n        <li *ngFor=\"let tab of tabs\" class=\"nav-item pointer\">\n            <span class=\"nav-link {{tab===activeTab?tabClass+' '+textClass:''}}\"\n            [class.active]=\"tab===activeTab\" (click)=\"changeTab(tab)\">{{tab}}</span>\n        </li>\n    </ul>"
                },] },
    ];
    /** @nocollapse */
    TabComponent.ctorParameters = function () { return []; };
    TabComponent.propDecorators = {
        "tabs": [{ type: core_1.Input },],
        "activeTab": [{ type: core_1.Input },],
        "position": [{ type: core_1.Input },],
        "target": [{ type: core_1.Input },],
        "tabChange": [{ type: core_1.Output },],
    };
    return TabComponent;
}(attr_class_1.DomAttr));
exports.TabComponent = TabComponent;
//# sourceMappingURL=tab.component.js.map