"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var attr_class_1 = require("../../commons/extends/attr.class");
var upload_data_1 = require("./upload.data");
var InputImageComponent = /** @class */ (function (_super) {
    __extends(InputImageComponent, _super);
    function InputImageComponent(domSanitizer) {
        var _this = _super.call(this) || this;
        _this.domSanitizer = domSanitizer;
        _this.fileChange = new core_1.EventEmitter(false);
        _this.srcChange = new core_1.EventEmitter(false);
        _this.showImage = false;
        _this.isLoading = false;
        _this.hasUpload = true;
        _this.width = '100px';
        _this.default = '';
        return _this;
    }
    Object.defineProperty(InputImageComponent.prototype, "plusBackground", {
        get: function () {
            return this.domSanitizer.bypassSecurityTrustStyle("url(" + upload_data_1.plusSvgData + ")");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputImageComponent.prototype, "source", {
        get: function () { return this.config ? (this.config.host || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputImageComponent.prototype, "realSrc", {
        get: function () {
            return typeof this.src === 'string' ? this.source + this.src : this.src.blobUrl;
        },
        enumerable: true,
        configurable: true
    });
    InputImageComponent.prototype.ngOnChanges = function (changes) {
        if (changes.src && !this.default) {
            this.default = changes.src.currentValue;
        }
    };
    InputImageComponent.prototype.getUrl = function () {
        return "url(" + this.realSrc + ")";
    };
    InputImageComponent.prototype.changeFile = function (files) {
        this.hasUpload = false;
        this.isLoading = false;
        this.file = files[0];
        if (files.length > 0) {
            this.fileChange.emit(files[0]);
            this.src = { blobUrl: window.URL.createObjectURL(files[0]) };
            this.showImage = true;
            if (!!this.config) {
                this.uploadFile();
            }
        }
    };
    InputImageComponent.prototype.resetInput = function (input) {
        this.showImage = false;
        this.isLoading = false;
        this.hasUpload = true;
        this.file = null;
        input.value = '';
        this.src = this.default || '';
        this.srcChange.emit(this.src);
    };
    InputImageComponent.prototype.cleanInput = function (input) {
        this.src = '';
        this.showImage = false;
        this.isLoading = false;
        this.hasUpload = true;
        this.file = null;
        input.value = '';
        this.srcChange.emit(this.src);
    };
    InputImageComponent.prototype.uploadFile = function () {
        var _this = this;
        if (this.hasUpload === true) {
            return;
        }
        if (this.file === null || this.file === undefined) {
            return;
        }
        this.hasUpload = true;
        this.isLoading = true;
        if (this.config.uploader !== undefined || this.config.uploader !== null) {
            this.config.uploader(this.file).subscribe(function (src) {
                _this.isLoading = false;
                _this.src = src;
                _this.srcChange.emit(src);
            });
        }
    };
    InputImageComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-image',
                    template: "\n    <div class=\"d-inline-block\">\n        <input #input_file class=\"d-none\" type=\"file\" accept=\"image/*\" (change)=\"changeFile($event.target.files);input_file.value=null\">\n        <div class=\"btn-group\" role=\"group\">\n            <button [class]=\"btnClass\" (click)=\"input_file.click()\" type=\"button\">\n                <i class=\"fa fa-file-image-o fa-fw\" aria-hidden=\"true\"></i>{{title||'Open File'}}</button>\n            <button [class]=\"btnClass\" (click)=\"resetInput(input_file)\" type=\"button\">\n                <i class=\"fa fa-refresh fa-fw\" aria-hidden=\"true\"></i>\n            </button>\n            <button [class]=\"btnClass\" (click)=\"cleanInput(input_file)\" type=\"button\">\n                <i class=\"fa fa-remove fa-fw\" aria-hidden=\"true\"></i>\n            </button>\n        </div>\n        <br>\n        <div *ngIf=\"!((!showImage&&!src)||isLoading)\"\n            [style.width]=\"width\" [style.height]=\"width\" class=\"img-thumbnail img-thumbnail-pad d-inline-block mt-2 mr-2 rounded-0\">\n            <div class=\"w-100 h-100 img-thumbnail-image\" [ngStyle]=\"{'background-image': getUrl()}\"></div>\n        </div>\n        <div *ngIf=\"((!showImage&&!src)&&!isLoading)\"\n            (click)=\"input_file.click()\"\n            [style.width]=\"width\" [style.height]=\"width\"\n            [style.backgroundImage]=\"plusBackground\"\n            class=\"pointer ts-plus-dom img-thumbnail img-thumbnail-pad d-inline-block mt-2 mr-2 rounded-0\">\n            <div class=\"w-100 h-100 img-thumbnail-image\"></div>\n        </div>\n        <div *ngIf=\"isLoading\"\n            class=\"img-thumbnail img-thumbnail-pad d-inline-block mt-2 mr-2 rounded-0\" [style.width]=\"width\" [style.height]=\"width\">\n            <div class=\"typing_loader\"></div>\n        </div>\n    </div>",
                    styles: [upload_data_1.styleStr]
                },] },
    ];
    /** @nocollapse */
    InputImageComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    InputImageComponent.propDecorators = {
        "config": [{ type: core_1.Input },],
        "src": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "fileChange": [{ type: core_1.Output },],
        "srcChange": [{ type: core_1.Output },],
    };
    return InputImageComponent;
}(attr_class_1.DomAttr));
exports.InputImageComponent = InputImageComponent;
//# sourceMappingURL=input-image.component.js.map