import { OnChanges, SimpleChanges, EventEmitter } from '@angular/core';
import { DomSanitizer, SafeStyle } from '@angular/platform-browser';
import { UploadConfig } from './upload.interface';
import { InputImages } from './input-images.class';
import { DomAttr } from '../../commons/extends/attr.class';
export declare class InputImagesComponent extends DomAttr implements OnChanges {
    private domSanitizer;
    src: string;
    title: string;
    config: UploadConfig;
    width: string;
    srcChange: EventEmitter<string>;
    fileChange: EventEmitter<File[]>;
    deleteChange: EventEmitter<any>;
    images: InputImages;
    uploading: boolean;
    default: string;
    readonly plusBackground: SafeStyle;
    constructor(domSanitizer: DomSanitizer);
    ngOnChanges(changes: SimpleChanges): void;
    changeFile(files: File[]): void;
    getUrl(image: {
        type: string;
        file: File;
        url: string;
        uploading: boolean;
    }): string;
    removeImage(index: number): void;
    uploadImage(): void;
    resetInput(input: HTMLInputElement): void;
}
