"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var input_images_class_1 = require("./input-images.class");
var attr_class_1 = require("../../commons/extends/attr.class");
var upload_data_1 = require("./upload.data");
var InputImagesComponent = /** @class */ (function (_super) {
    __extends(InputImagesComponent, _super);
    function InputImagesComponent(domSanitizer) {
        var _this = _super.call(this) || this;
        _this.domSanitizer = domSanitizer;
        _this.srcChange = new core_1.EventEmitter(false);
        _this.fileChange = new core_1.EventEmitter(false);
        _this.deleteChange = new core_1.EventEmitter(false);
        _this.images = new input_images_class_1.InputImages();
        _this.uploading = false;
        _this.src = '';
        _this.config = { host: '' };
        _this.default = '';
        _this.width = '100px';
        return _this;
    }
    Object.defineProperty(InputImagesComponent.prototype, "plusBackground", {
        get: function () {
            return this.domSanitizer.bypassSecurityTrustStyle("url(" + upload_data_1.plusSvgData + ")");
        },
        enumerable: true,
        configurable: true
    });
    InputImagesComponent.prototype.ngOnChanges = function (changes) {
        if (!this.uploading) {
            this.images = new input_images_class_1.InputImages(this.src);
            if (changes.src && !this.default) {
                this.default = changes.src.currentValue;
            }
        }
    };
    InputImagesComponent.prototype.changeFile = function (files) {
        for (var i = 0; i < files.length; i++) {
            var url = window.URL.createObjectURL(files[i]);
            this.images.push({ type: 'file', file: files[i], url: url, uploading: !!this.config.uploader });
            this.fileChange.emit(files);
        }
        if (this.config.uploader) {
            this.uploadImage();
        }
    };
    InputImagesComponent.prototype.getUrl = function (image) {
        if (image.type === 'file') {
            return "url(" + image.url + ")";
        }
        else {
            return "url(" + (image.url ? this.config.host + image.url : '');
        }
    };
    InputImagesComponent.prototype.removeImage = function (index) {
        this.deleteChange.emit(this.images.list[index]);
        this.images.remove(index);
        this.srcChange.emit(this.images.urls.join());
    };
    InputImagesComponent.prototype.uploadImage = function () {
        var _this = this;
        var fileItems = this.images.fileItems;
        var cx = 0;
        this.uploading = true;
        var _loop_1 = function (i) {
            this_1.config.uploader(fileItems[i].file).subscribe(function (res) {
                fileItems[i].type = 'url';
                fileItems[i].uploading = false;
                fileItems[i].file = null;
                fileItems[i].url = res;
                _this.srcChange.emit(_this.images.urls.join());
                if (++cx === fileItems.length) {
                    _this.uploading = false;
                }
            });
        };
        var this_1 = this;
        for (var i = 0; i < fileItems.length; i++) {
            _loop_1(i);
        }
    };
    InputImagesComponent.prototype.resetInput = function (input) {
        this.src = this.default;
        this.images = new input_images_class_1.InputImages(this.src);
        input.value = '';
        this.uploading = false;
        this.srcChange.emit(this.images.urls.join());
    };
    InputImagesComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-images',
                    template: "\n    <div class=\"d-inline-block\">\n    <input #input_file type=\"file\"\n    class=\"d-none\" accept=\"image/*\" multiple=\"multiple\" (change)=\"changeFile($event.target.files);input_file.value=null\">\n    <div class=\"btn-group\" role=\"group\">\n        <button type=\"button\" [class]=\"btnClass\" (click)=\"input_file.click()\">\n            <i class=\"fa fa-file-image-o fa-fw\" aria-hidden=\"true\"></i>{{title||'Open File'}}</button>\n        <button type=\"button\" [class]=\"btnClass\" (click)=\"resetInput(input_file)\">\n            <i class=\"fa fa-refresh fa-fw\" aria-hidden=\"true\"></i>\n        </button>\n    </div>\n    <br>\n    <div *ngFor=\"let item of images.list;index as i\"\n        [style.width]=\"width\" [style.height]=\"width\" class=\"img-thumbnail img-thumbnail-pad d-inline-block mt-2 mr-2 rounded-0\">\n        <span *ngIf=\"!item.uploading\" class=\"close text-danger\" (click)=\"removeImage(i)\">&times;</span>\n        <div *ngIf=\"!item.uploading\" class=\"w-100 h-100 img-thumbnail-image\" [ngStyle]=\"{'background-image': getUrl(item)}\"></div>\n        <div *ngIf=\"item.uploading\" class=\"span mt-2 w-100 h-100\">\n            <div class=\"typing_loader\"></div>\n        </div>\n    </div>\n    <div *ngIf=\"images.list.length<=0\"\n        (click)=\"input_file.click()\" class=\"pointer ts-plus-dom img-thumbnail img-thumbnail-pad d-inline-block mt-2 mr-2 rounded-0\"\n        [style.width]=\"width\" [style.height]=\"width\" [style.backgroundImage]=\"plusBackground\">\n    </div>\n</div>",
                    styles: [upload_data_1.styleStr]
                },] },
    ];
    /** @nocollapse */
    InputImagesComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    InputImagesComponent.propDecorators = {
        "src": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "config": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "srcChange": [{ type: core_1.Output },],
        "fileChange": [{ type: core_1.Output },],
        "deleteChange": [{ type: core_1.Output },],
    };
    return InputImagesComponent;
}(attr_class_1.DomAttr));
exports.InputImagesComponent = InputImagesComponent;
//# sourceMappingURL=input-images.component.js.map