import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';
import { UploadConfig } from './upload.interface';
import { DomAttr } from '../../commons/extends/attr.class';
import { Subscription } from 'rxjs/Subscription';
export declare class InputVideoComponent extends DomAttr implements OnChanges {
    private sanitizer;
    src: string | SafeResourceUrl;
    videoSize: [string, string];
    title: string;
    type: string;
    autoUpload: boolean;
    useUpload: boolean;
    config: UploadConfig;
    fileChange: EventEmitter<File>;
    srcChange: EventEmitter<string>;
    showVideo: boolean;
    showLoading: boolean;
    hasUpload: boolean;
    loaded: string;
    file: File;
    subscription: Subscription;
    readonly source: string;
    readonly realSrc: string | SafeResourceUrl;
    constructor(sanitizer: DomSanitizer);
    ngOnChanges(changes: SimpleChanges): void;
    changeFile(files: File[]): void;
    cleanInput(): void;
    tryUpload(): void;
}
