"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var BaseChartDirective = /** @class */ (function () {
    function BaseChartDirective(elementRef) {
        this.elementRef = elementRef;
        this.ready = false;
        this.options = {};
    }
    BaseChartDirective.prototype.ngOnChanges = function (change) {
        this.updateChart();
    };
    BaseChartDirective.prototype.ngAfterViewInit = function () {
        this.canvas = this.elementRef.nativeElement;
        this.chart = new window.Chart(this.canvas, { type: this.type, options: this.options });
        this.ready = true;
        this.updateChart();
    };
    BaseChartDirective.prototype.updateChart = function () {
        if (this.ready) {
            this.chart.data = this.data;
            this.chart.update();
        }
    };
    BaseChartDirective.prototype.toBase64Image = function () {
        return this.ready ? this.chart.toBase64Image() : '';
    };
    BaseChartDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'canvas[baseChart]',
                    exportAs: 'baseChart',
                },] },
    ];
    /** @nocollapse */
    BaseChartDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    BaseChartDirective.propDecorators = {
        "data": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
    };
    return BaseChartDirective;
}());
exports.BaseChartDirective = BaseChartDirective;
//# sourceMappingURL=base-chart.directive.js.map