"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var script_service_1 = require("./../../commons/services/script.service");
var BaseEchartDirective = /** @class */ (function () {
    function BaseEchartDirective(script, elementRef) {
        this.script = script;
        this.elementRef = elementRef;
        this.chartLoad = new core_1.EventEmitter();
    }
    BaseEchartDirective.prototype.ngOnInit = function () {
        this.script.load(this.src, window.echarts);
    };
    BaseEchartDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.script.complete(function () {
            _this.echart = window.echarts.init(_this.elementRef.nativeElement);
            _this.echart.setOption(_this.option);
            _this.chartLoad.emit(_this.echart);
        });
    };
    BaseEchartDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'div[baseEchart]',
                    exportAs: 'baseEchart',
                },] },
    ];
    /** @nocollapse */
    BaseEchartDirective.ctorParameters = function () { return [
        { type: script_service_1.ScriptService, },
        { type: core_1.ElementRef, },
    ]; };
    BaseEchartDirective.propDecorators = {
        "src": [{ type: core_1.Input },],
        "option": [{ type: core_1.Input },],
        "chartLoad": [{ type: core_1.Output },],
    };
    return BaseEchartDirective;
}());
exports.BaseEchartDirective = BaseEchartDirective;
//# sourceMappingURL=echart.directive.js.map