"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var map_service_1 = require("./map.service");
var default_config_1 = require("./default.config");
var Subject_1 = require("rxjs/Subject");
var MapDirective = /** @class */ (function () {
    function MapDirective(elementRef, mapService) {
        this.elementRef = elementRef;
        this.mapService = mapService;
        this.center = [116.39, 39.9];
        this.zoom = 10;
        this.options = default_config_1.DefaultConfig;
        this.status = false;
        this.sub = new Subject_1.Subject();
        this.handle = this.sub.asObservable();
    }
    Object.defineProperty(MapDirective.prototype, "mapOptions", {
        get: function () {
            var options = {
                zoom: this.zoom,
                center: this.center,
                mapStyle: this.options.mapStyle,
            };
            return options;
        },
        enumerable: true,
        configurable: true
    });
    MapDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.mapService.doFuc(function (amap) {
            _this.amap = amap;
            _this.options.zoom = _this.zoom;
            _this.options.center = _this.center;
            _this.map = new amap.Map(_this.elementRef.nativeElement, _this.mapOptions);
            _this.sub.next();
            _this.sub.complete();
            _this.status = true;
        });
    };
    MapDirective.prototype.ngOnDestroy = function () { };
    MapDirective.prototype.doFunc = function (func) {
        if (this.status) {
            func();
        }
        else {
            this.handle.subscribe(func);
        }
    };
    MapDirective.prototype.setMarker = function (position) {
        var _this = this;
        this.doFunc(function () {
            var map = _this.map;
            if (!_this.marker) {
                _this.marker = new _this.amap.Marker({
                    position: position
                });
                _this.marker.setMap(map);
            }
            else {
                _this.marker.setPosition(position);
            }
            _this.map.setCenter(position);
        });
    };
    MapDirective.prototype.setCenter = function (center) {
        var _this = this;
        this.doFunc(function () { return _this.map.setCenter(center); });
    };
    MapDirective.prototype.setMapStyle = function (mapStyle) {
        var _this = this;
        this.doFunc(function () { return _this.map.setMapStyle(mapStyle); });
    };
    MapDirective.prototype.setZoom = function (zoom) {
        var _this = this;
        this.doFunc(function () { return _this.map.setZoom(zoom); });
    };
    MapDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'div[ts-map]',
                    exportAs: 'tsMap',
                },] },
    ];
    /** @nocollapse */
    MapDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: map_service_1.MapService, },
    ]; };
    MapDirective.propDecorators = {
        "center": [{ type: core_1.Input },],
        "zoom": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
    };
    return MapDirective;
}());
exports.MapDirective = MapDirective;
//# sourceMappingURL=map.directive.js.map